<template>
  <div class="section4" id="section4" style="padding-bottom: 30vh !important">
    <div class="camp-menu camp-menu-track d-none d-lg-block">
      <ul class="row m-0" v-for="index in 5" :key="index">
        <li @click="handleSlideClick(index)" :class="['col', 'camp-icon' + index, { active: index == campCurrent }]">
          <img :src="require('../../../assets/images/frontend/camo-menu-' + (index - 1) + '.svg')" />
        </li>
      </ul>
    </div>

    <div class="camp-holder">
      <div id="camp-struct"></div>
      <transition @before-enter="beforeEnter" @enter="enter" @leave="leave" appear class="slider-holder"
        >\
        <div
          v-if="camp.id === campCurrent"
          v-for="camp in camp_data"
          :key="camp.id"
          :class="['camp-slider', 'camp', 'camp' + camp.id]"
        >
          <div class="row m-0 space">
            <div class="col-12 col-md text-center text-sm-left" v-if="announceTime.check" style="margin-top: 15vh">
              <img :src="camp.smLogo" class="w-100" />
            </div>
            <div class="col-12 col-md">
              <div class="textbox">
                <div class="text-sub" style="display:flex; align-items: center; margin-bottom: 30px;">
                  <div class="pinned">
                    <div class="pin"></div>
                    <div class="pin"></div>
                    <div class="pin"></div>
                    <div class="pin"></div>
                  </div>
                  <span class="font-somatic">CAMP</span>
                </div>
                <div class="text-main row m-0" style="margin-top:30px">
                  <!-- <span class="color-white" style="font-size: 100px">เปิดรับสมัคร</span><br /> -->
                  <span style="font-size: 60px; color: rgba(255,255,255,0.7);">{{ camp.name }}</span>
                </div>
              </div>
              <div class="textboard">
                <div class="row">
                  <div class="col">
                    <!-- <span>{{camp.desc}}</span> -->
                  </div>
                </div>
                <div class="row img-block m-0" v-if="!announceTime.check">
                  <div class="col-4 text-center pl-0" v-for="(data, index) in camp.focus" :key="index">
                    <img :src="data.img" />
                    <span>{{ data.text }}</span>
                  </div>
                </div>
                <div class="row m-0 mt-4 e" v-if="!announceTime.check">
                  <a>
                    <div class="btn btn-fade">
                      ยืนยันสิทธิ์
                    </div>
                  </a>
                </div>
              </div>
            </div>
            <div class="col d-none d-md-block" v-if="!announceTime.check">
              <div class="textbox text-center camp-icon">
                <img :src="camp.logo" />
              </div>
            </div>
            <div class="col-12 mb-5 mt-3">
              <div class="row b" v-if="announceTime.check">
                <div class="col-12 col-md mt-3">
                  <div class="announce-block">
                    <div class="announce-head">
                      รายชื่อตัวจริง
                    </div>
                    <div class="announce-body">
                      <div
                        class="row mr-0 ml-0 mt-2 mb-2 announce-item"
                        v-for="(nameList, count) in camp.qualified.main"
                        :key="count"
                      >
                        <div class="col-2">
                          <div class="nameList-num">{{ count + 1 }}</div>
                        </div>
                        <div class="col">
                          <div class="nameList-name">{{ nameList.name }}</div>
                        </div>
                      </div>
                    </div>
                  </div>
                </div>
                <div class="col-12 col-md mt-3 mb-5">
                  <div class="announce-block">
                    <div class="announce-head">
                      รายชื่อตัวสำรอง
                    </div>
                    <div class="announce-body">
                      <div
                        class="row mr-0 ml-0 mt-2 mb-2 announce-item"
                        v-for="(nameList, count) in camp.qualified.sub"
                        :key="count"
                      >
                        <div class="col-2">
                          <div class="nameList-num">{{ count + 1 }}</div>
                        </div>
                        <div class="col">
                          <div class="nameList-name">{{ nameList.name }}</div>
                        </div>
                      </div>
                    </div>
                  </div>
                </div>
              </div>
              <div class="row m-0 announce-desc color-white" v-if="announceTime.check">
                <br />
                <!-- {{ camp.desc }} -->
                <span style="colo:#373a4c; font-weight:bold;">หมายเหตุ : </span>
                <span class="color-white">
                  สำหรับน้อง ๆ ที่เป็น ตัวสำรอง จะมี พี่ ๆ ติดต่อกลับหลังจากที่ ตัวจริง สละสิทธิ์
                  โดยเรียกขึ้นมาตามลำดับที่ปรากฏ นะครับ<br
                /></span>
              </div>
              <div class="row announce-button" v-if="announceTime.check">
                <div class="button-border" style="cursor: default;">
                  <div class="button-core" style="padding: 10px 70px">
                    หมดเวลายืนยันสิทธิ์
                  </div>
                </div>
              </div>
            </div>
            <div class="row m-0 w-100" v-if="!announceTime.check">
              <div class="col-12 h5 text-center w-100" style="font-weight:200; color: #f2f2f2">
                เนื่องจากระบบประกาศผลที่ได้ประกาศไปก่อนหน้านี้เป็นความบกพร่องของระบบ จึงทำให้เกิดความเข้าใจผิด
                และความสับสน ทั้งนี้จึงขอทำการชี้แจงว่า ผลประกาศที่ผ่านมาไม่ถือเป็นทางการและต้องขออภัยมา ณ ที่นี้ด้วย
                <br />
              </div>
              <div class="col-12 h5 text-center w-100" style="font-weight:normal; color: #f2f2f2">
                รอติดตามผลประกาศผู้มีสิทธิเข้าร่วมอย่างเป็นทางการได้เร็ว ๆ นี้
              </div>
            </div>
          </div>
        </div>
      </transition>
    </div>
    <div class="camp-menu2 camp-menu-track menu-2 d-lg-none">
      <ul class="row ml-0 mr-0">
        <li
          @click="handleSlideClick(index)"
          :class="['col', 'camp-icon' + index, { active: index == campCurrent }]"
          v-for="index in 5"
          :key="index"
        >
          <img :src="require('../../../assets/images/frontend/camo-menu-' + (index - 1) + '.svg')" />
        </li>
      </ul>
    </div>
  </div>
</template>

<script>
import { mapMutations, mapGetters, mapActions } from 'vuex';
import Velocity from 'velocity-animate';
export default {
  name: 'CampSlide',
  data() {
    return {
      userSelected: false,
      announceTime: {
        today: new Date().getDate() + '/' + new Date().getMonth() + '/' + new Date().getFullYear(),
        announce: '13/4/2018',
        check: new Date().getDate() + '/' + new Date().getMonth() + '/' + new Date().getFullYear() >= '13/4/2018'
      },
      camp_data: [
        {
          id: 1,
          name: 'APPLIDANUS',
          desc:
            '“มาทำแอปฯกันดีกว่า!” มาสร้างแอปพลิเคชันบนแพลตฟอร์มยอดนิยมอย่าง iOS กับค่าย Appridanus โดยใช้ภาษา Swift ผ่านโปรแกรม Xcode เนรมิตรให้กลายเป็นแอปพลิเคชันสุดว้าว นี่จะมีพี่ๆสุดแสนใจดี ที่พร้อมให้ความรู้ และคำแนะนำกับน้อง ๆ ในค่ายอย่างเเน่นอน รออะไรกันอยู่ล่ะ กดปุ่มสมัครเลย!',
          focus: [
            {
              img: require('../../../assets/images/camp/app-1.svg'),
              text: 'แอปพลิเคชันระบบ iOS'
            },
            {
              img: require('../../../assets/images/camp/app-2.svg'),
              text: 'เรียนรู้ภาษา Swift 4'
            },
            {
              img: require('../../../assets/images/camp/app-3.svg'),
              text: 'เรียนรู้การใช้ Xcode'
            }
          ],
          logo: require('../../../assets/images/camp/applidanus.svg'),
          smLogo: require('../../../assets/images/camp/small/applidanus.svg'),
          qualified: {
            main: 20,
            sub: 10
          }
        },
        {
          id: 2,
          name: 'I-OPOLLO',
          desc:
            'ในวันที่อินเทอร์เน็ตเข้าถึงทุก ๆ สิ่งรอบตัวเรา จะดีแค่ไหนกันถ้าเราสามารถควบคุมเครื่องใช้ไฟฟ้าได้ ไม่ว่าจะอยู่ไกลแค่ไหนผ่านโทรศัพท์ของน้องเอง เรียนรู้ถึงสิ่งประดิษฐ์สุดคูลที่จะทำให้ชีวิตของเราสะดวกสบายมากยิ่งขึ้นมาสร้างสรรค์และเปลี่ยนแปลงของใช้ธรรมดาๆที่น้องคุ้นเคยอยู่ทุกวันให้ฉลาดขึ้นจากไอเดียสุดบรรเจิดด้วย Internet of Things กันเถอะ!',
          focus: [
            {
              img: require('../../../assets/images/camp/iot-1.svg'),
              text: 'โปรแกรมบอร์ด'
            },
            {
              img: require('../../../assets/images/camp/iot-2.svg'),
              text: 'ต่อเซนเซอร์'
            },
            {
              img: require('../../../assets/images/camp/iot-3.svg'),
              text: 'ประยุกต์กับ Firebase'
            }
          ],
          logo: require('../../../assets/images/camp/opollo.svg'),
          smLogo: require('../../../assets/images/camp/small/i-opollo.svg'),
          qualified: {
            main: 10,
            sub: 5
          }
        },
        {
          id: 3,
          name: 'NETWORK STELLAR',
          desc:
            'พร้อมกันหรือยัง? กับค่าย NetworkStellar ที่จะพาน้องๆ มาไขความลับของการทำงานบนโครงสร้างระบบเครือข่าย ถ้าอยากรู้ว่าอินเทอร์เน็ตที่เราใช้กันอยู่ทำงานได้ยังไง พี่ๆ จะพาน้องๆไปพบกับคำตอบเอง! นอกจากความรู้แล้ว ยังมีความสนุกรอน้องๆ อยู่อีกด้วย ได้ทั้งความรู้ ได้ทั้งประสบการณ์อย่างงี้ จะพลาดได้ไง!!',
          focus: [
            {
              img: require('../../../assets/images/camp/network-1.svg'),
              text: 'ได้รู้ประเภทเครือข่ายคอมพิวเตอร์'
            },
            {
              img: require('../../../assets/images/camp/network-2.svg'),
              text: 'ได้ใช้อุปกรณ์เครือข่ายจริง'
            },
            {
              img: require('../../../assets/images/camp/network-3.svg'),
              text: 'ได้รู้การทำงานของ Internet'
            }
          ],
          logo: require('../../../assets/images/camp/network.svg'),
          smLogo: require('../../../assets/images/camp/small/networkstellar.svg'),
          qualified: {
            main: 10,
            sub: 5
          }
        },
        {
          id: 4,
          name: 'GAME ORION',
          desc:
            'มาเปลี่ยนบทบาทจากผู้เล่นเป็นผู้สร้างกับค่าย Gameorion กันเถอะ น้อง ๆ จะได้เรียนรู้หลักการโปรแกรมมิ่งเล็ก ๆ น้อย ๆ ผ่านการสร้างเกม และยังได้สร้างสรรค์เกมในจินตนาการด้วยโปรแกรม Construct 2 ที่ใช้งานได้อย่างง่ายดาย เล่นเกมก็สนุกแล้ว แต่สร้างเกมก็จะสนุกไปอีกแบบ ถ้าอยากรู้ว่าเป็นยังไง ก็มาเป็นส่วนหนึ่งในค่าย Gameorion กันได้เลย',
          focus: [
            {
              img: require('../../../assets/images/camp/game-1.svg'),
              text: 'ได้รู้ Game Theory'
            },
            {
              img: require('../../../assets/images/camp/game-2.svg'),
              text: 'ฝึกใช้ Construct2'
            },
            {
              img: require('../../../assets/images/camp/game-3.svg'),
              text: 'ได้เรียนรู้การสร้างเกม'
            }
          ],
          logo: require('../../../assets/images/camp/gameorion.svg'),
          smLogo: require('../../../assets/images/camp/small/gameorion.svg'),
          qualified: {
            main: 10,
            sub: 5
          }
        },

        {
          id: 5,
          name: 'DTA48',
          desc:
            '"ให้ Rapidminer ทำนายกัน" มาเปลี่ยนข้อมูลรอบตัวเราให้เป็นดั่งเวทย์มนต์ที่มองเห็นอนาคตด้วย Rapidminer โปรแกรมที่จะเนรมิตข้อมูลแสนธรรมดาให้เป็นแบบจำลองหยั่งรู้อนาคตได้เพียงแค่ปลายนิ้วสัมผัส พี่ๆทุกคนพร้อมที่จะมอบความรู้ ความสนุก ความอบอุ่นให้แบบไม่อั้น "แอบรอน้องอยู่นะจ๊ะ แต่น้องไม่รู้บ้างเลย" เพราะฉะนั้นจะรอช้าอยู่ไย สมัครเลย!',
          focus: [
            {
              img: require('../../../assets/images/camp/data-1.svg'),
              text: 'Business Challenge'
            },
            {
              img: require('../../../assets/images/camp/data-2.svg'),
              text: 'Data Analysis'
            },
            {
              img: require('../../../assets/images/camp/data-3.svg'),
              text: 'Machine Learning'
            }
          ],
          logo: require('../../../assets/images/camp/dta48.svg'),
          smLogo: require('../../../assets/images/camp/small/dta-48.svg'),
          qualified: {
            main: 10,
            sub: 5
          }
        }
      ],
      campCurrent: 1,
      campBefore: 1
    };
  },
  created() {
    var userInfo = this.getUserProgress();
    if (userInfo) {
      if (userInfo.status == 'Completed!') this.userSelected = true;
      else this.userSelected = false;
    }

    // this.getAnnouncement().then((response) => {
    //   var announceData = response.data;
    //   for (var key in announceData) {
    //     for (var type in announceData[key]) {
    //       if (key == 'app') {
    //         if (type == 'select') {
    //           this.camp_data[0].qualified.main = announceData[key][type];
    //         } else {
    //           this.camp_data[0].qualified.sub = announceData[key][type];
    //         }
    //       }
    //       if (key == 'iot') {
    //         if (type == 'select') {
    //           this.camp_data[1].qualified.main = announceData[key][type];
    //         } else {
    //           this.camp_data[1].qualified.sub = announceData[key][type];
    //         }
    //       }
    //       if (key == 'network') {
    //         if (type == 'select') {
    //           this.camp_data[2].qualified.main = announceData[key][type];
    //         } else {
    //           this.camp_data[2].qualified.sub = announceData[key][type];
    //         }
    //       }
    //       if (key == 'game') {
    //         if (type == 'select') {
    //           this.camp_data[3].qualified.main = announceData[key][type];
    //         } else {
    //           this.camp_data[3].qualified.sub = announceData[key][type];
    //         }
    //       }
    //       if (key == 'data') {
    //         if (type == 'select') {
    //           this.camp_data[4].qualified.main = announceData[key][type];
    //         } else {
    //           this.camp_data[4].qualified.sub = announceData[key][type];
    //         }
    //       }
    //     }
    //   }
    // });
  },
  methods: {
    ...mapMutations(['forceCamp']),
    ...mapActions(['getAnnouncement']),
    ...mapGetters(['getUserProgress']),
    forcePage(name) {
      this.forceCamp(name);
    },
    handleSlideClick(id) {
      this.campBefore = this.campCurrent;
      this.campCurrent = id;
    },
    beforeEnter: function(el) {
      if (this.campCurrent > this.campBefore) {
        Velocity(el, { opacity: 0, translateX: '100vw' });
      } else {
        Velocity(el, { opacity: 0, translateX: '-100vw' });
      }
      this.campBgChange();
    },
    enter: function(el, done) {
      Velocity(el, { opacity: 1, translateX: 'none' }, { duration: 200 }, { complete: done });
    },
    leave: function(el, done) {
      if (this.campBefore > this.campCurrent) {
        Velocity(el, { opacity: 0, translateX: '100vw' }, { duration: 200 }, { display: 'none' });
      } else {
        Velocity(el, { opacity: 0, translateX: '-100vw' }, { duration: 200 }, { display: 'none' });
      }
      Velocity(el, { complete: done });
    },
    campBgChange() {
      if (this.campCurrent == 5) {
        TweenLite.to('.section4', 0.7, {
          backgroundImage: '-webkit-linear-gradient(top, #3c1053, #ad5389)'
        });
      }
      if (this.campCurrent == 1) {
        TweenLite.to('.section4', 0.7, {
          backgroundImage: '-webkit-linear-gradient(top, #514a9d, #24c6dc)'
        });
      }
      if (this.campCurrent == 3) {
        TweenLite.to('.section4', 0.7, {
          backgroundImage: '-webkit-linear-gradient(top, #77272d, #ed3d24)'
        });
      }
      if (this.campCurrent == 2) {
        TweenLite.to('.section4', 0.7, {
          backgroundImage: '-webkit-linear-gradient(top, #f17e2c, #ffef6a)'
        });
      }
      if (this.campCurrent == 4) {
        TweenLite.to('.section4', 0.7, {
          backgroundImage: '-webkit-linear-gradient(top, #006837, #8cc63f)'
        });
      }
    }
  }
};
</script>

<style lang="scss" scoped>
@media screen and (max-height: 700px) {
  .section4 {
    height: 950px;
  }
}

@media screen and (min-height: 701px) {
  .section4 {
    height: 870px;
  }
}
</style>